package com.flyfish.framework.initializer;

import com.flyfish.framework.domain.UserQo;
import com.flyfish.framework.domain.po.Role;
import com.flyfish.framework.domain.po.User;
import com.flyfish.framework.enums.RoleType;
import com.flyfish.framework.enums.UserStatus;
import com.flyfish.framework.enums.UserType;
import com.flyfish.framework.service.UserService;
import org.springframework.security.crypto.password.PasswordEncoder;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.Arrays;

/**
 * 用户初始化器，可以重写
 */
@Component
public class UserInitializer {

    @Resource
    private UserService userService;
    @Resource
    private PasswordEncoder passwordEncoder;

    /**
     * 生成超级管理员
     */
    @PostConstruct
    private void init() {
        UserQo qo = new UserQo();
        qo.setUserType(UserType.SUPER_ADMIN.name());
        if (userService.count(qo) == 0) {
            User user = new User();
            user.setUsername("admin");
            user.setPassword(passwordEncoder.encode("admin"));
            user.setUserType(UserType.SUPER_ADMIN);
            user.setEnable(true);
            user.setApp(false);
            user.setUserStatus(UserStatus.NORMAL);
            user.setRoles(Arrays.asList(Role.builder()
                    .type(RoleType.PC)
                    .admin(true)
                    .description("超级管理员")
                    .permissions(Arrays.asList())
                    .build()));
            user.setPhone("10000000000");
            user.setName("超级管理员");
            user.setCode("Administrator");
            userService.createSelective(user);
        }
    }
}
